// It's like magic!
loc = document.location.pathname.split('/');
matchID = loc[2];

socket = {
	connect: function() {
		// This is our base socket
		socket.s = false;
		try {
			socket.s = new WebSocket("ws://localhost:10081");
			socket.s.onopen = function() {
				// FIXME: Will need to move this to execute when something's received from the server (and within connectStatus switch)
				pong.init(2);
				
				if(loc.length == 3 && loc[1] == "match") {
					socket.sendMessage('newPlayer', matchID);
				}
			}
			
			socket.s.onmessage = function(msg) {
				if(data = JSON.parse(msg.data)) {
					console.log(data);
					recUID = data.uid;
					recVal = data.val;
					switch(data.name) {
						case 'uid':
							// TODO: Tell the server we don't need a new UID if we already have one
							localStorage['uid'] = recVal;
							break;							
						case 'matchFound':
							document.location.pathname = "/match/" + recVal;
							break;
						case 'connectStatus':
							switch(recVal) {
								case 'newGame':
									$('#scratch').append('<li>New game (UID: ' + recUID + ')</li>');
									break;
								case 'playerAdded':									
									$('#scratch').append('<li>Player added (UID: ' + recUID + ')</li>');
									break;
								case 'playerDisconnected':
									$('#scratch').append('<li>Player disconnected (UID: ' + recUID + ')</li>');
									break;
								case 'gameFull':
									$('#scratch').append('<li>Game full (UID: ' + recUID + ')</li>');
									break;
								default: 
									$('#scratch').append('<li>Unrecognized connect status (UID: ' + recUID + ')</li>');
									break;
							}
							break;
						case 'updatePaddlePos':
							data = data.val;
							pong.updatePaddlePos(data.playerID, data.newPos);
							break;
						case 'updateBallPos':
							pong.updateBallPos(data.val.newPos);
							break;
						default:
							console.error('UNRECOGNISED DATA: Name: ' + data.name + ', Val: ' + data.val);
							break;
					}
				} else { // Invalid data
					console.log('Invalid data');
				}
			}
			
			socket.s.onclose = function() {
				console.log('Connection closed');
			}
		} catch(exception) {
			console.log('Couldn\'t establish a connection');
		}
	},
	
	sendMessage: function(messageName, messageVal) {
		data = {
			matchID: matchID,
			uid: localStorage['uid'],
			name: messageName,
			val: messageVal
		}
		try {
			socket.s.send(JSON.stringify(data));
		} catch(exception) {
			console.log('Couldn\'t send message');
		}
	},
	
	findMatch: function() {
		socket.sendMessage('findMatch');
	},
}