require 'vendor/web_socket.rb'
require 'thread'
require 'rubygems'
require 'json'

class Server
	attr_accessor :connections, :matches, :uid, :curr_match
	
	def initialize
		@connections = []
		# TODO: Store this in SQLite
		@matches = {}
	end
	
	# Adds a new connection to the array
	def new_connection(que)
		@connections.push(que)
	end
	
	def generate_uid
		# TODO: Only need a unique ID if one has not already been set in localStorage on client side
    @uid = (0...10).map{65.+(rand(25)).chr}.join.downcase!
	end
	
	def find_match
		if matches.length == 0
			
		else
			
		end
	end
	
	def format_message(uid, name, val)
	  "{ \"uid\": \"#{ uid }\", \"name\": \"#{ name }\", \"val\": \"#{ val }\" }"
	end
	
	def send_to_match(match_id, msg)
		# Put some code here (it would be spiffing it worked)
	end
	
	# This function will send the message to everybody in the connection
	def send_to_all(msg, val)
		for conn in @connections
			conn.push(format_message(@uid, msg, val))
		end
	end
end

class Match
	attr_reader :match_id
	attr_accessor :players, :player_count
	
	def initialize(match_id)
		@match_id = match_id
		@players = []
		@player_count = 0
	end
	
	def add_uid? (uid)
		@player_count.include?(uid) ? false : true
	end
	
	def game_full?
		@player_count < 2 ? false : true
	end
end

s = Server.new

server = WebSocketServer.new(:port => 10081, :accepted_domains => ['localhost'])
server.run() do |ws|
	begin
    # FIXME: Limit data to just send to specific match that the player is connected to
    ws.handshake()
    que = Queue.new()
    s.new_connection(que)
		s.generate_uid
		
		# FIXME: Undefined local variable
		def send_to_user(msg, val)
			ws.send(s.format_message(s.uid, msg, val))
		end
		
		send_to_user('uid', s.uid)

    thread = Thread.new() do
      while true
        new_data = que.pop()
        ws.send(new_data)
      end
    end

    while data = ws.receive()
      puts "Received: #{ data }"
			# Parse the data we've received to JSON (all data passed between JS and Ruby is formatted in JSON)
			rec_data = JSON.parse(data)
			
      case rec_data['name']
				when "findMatch"
						# ws.send will only send this to the specific client it comes from
						if s.matches.length == 0
							send_to_user('matchFound', 1)
						else
							send_to_user('matchFound', s.matches.length) if s.matches[matches.length].player_count < 2
							send_to_user('matchFound', s.matches.length + 1) if s.matches[matches.length].player_count > 2
						end
        when "newPlayer"
          val = val.to_i
          if val.integer? && val > 0 # Make sure this isn't something malicious
            s.curr_match = val
            if matches.has_key?(val) # There's already at least one person in this match
							p matches
            end
          else # Awww, shit
            s.send_to_all('error', 'Malformed match ID')
          end
      end
    end

  ensure
		# FIXME: Users are getting disconnected and immediately reconnected when a new player connects, I think something is throwing us out of the thread/que
    s.connections.delete(que)
    thread.terminate() if thread
    # Banish the player (we don't want to remove their UID incase they reconnect)
    s.matches[s.curr_match].player_count -= 1 if s.matches.has_key?(s.curr_match)
		s.send_to_all('connectStatus', 'playerDisconnected')
  end
end